/*
 * Initial main.c file generated by Glade. Edit as required.
 * Glade will not overwrite this file.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "interface.h"
#include "support.h"

//
#include "callbacks.h"

//-------------------------------------------------------------------------------------------------
// : Net control 
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <arpa/inet.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <pthread.h>
//-------------------------------------------------------------------------------------------------
// : H/W control moduel
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
//-------------------------------------------------------------------------------------------------
// : Net control module
#define BUFSIZE	1024
//-------------------------------------------------------------------------------------------------
// : Net control module
int serv_sock;
int clnt_sock;
char message[BUFSIZE];
int str_len;
struct sockaddr_in serv_addr;
struct sockaddr_in clnt_addr;
int clnt_addr_size;
int flag;
//-------------------------------------------------------------------------------------------------
// : H/W control module
int fd;
int lp;
unsigned char buff[128];
//-------------------------------------------------------------------------------------------------
// : Net control module
void thread_initial(void);
void *thread_myloop(void *arg);
//-------------------------------------------------------------------------------------------------
// : H/W control module
void signal_stop(void);
void signal_advance(void);
void signal_left(void);
void signal_right(void);
void signal_down(void);
//-------------------------------------------------------------------------------------------------


g_flag_master = 1;


//-------------------------------------------------------------------------------------------------
// MAIN
int
main (int argc, char *argv[])
{
  GtkWidget *window1;

#ifdef ENABLE_NLS
  bindtextdomain (GETTEXT_PACKAGE, PACKAGE_LOCALE_DIR);
  bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
  textdomain (GETTEXT_PACKAGE);
#endif

  gtk_set_locale ();
  gtk_init (&argc, &argv);

  add_pixmap_directory (PACKAGE_DATA_DIR "/" PACKAGE "/pixmaps");

  /*
   * The following code was added by Glade to create one of each component
   * (except popup menus), just so that you see something after building
   * the project. Delete any components that you don't want shown initially.
   */
  window1 = create_window1 ();
  gtk_widget_show (window1);
  
  	// ===>
	g_printf("thread start. \n");
	// ===> thread myloop
  	thread_initial();

  	// ===>
	int state;
	pthread_t t_id;
	void *t_return;

	state = pthread_create(&t_id, NULL, thread_myloop, NULL);	
	if(state != 0){
		g_printf("thread error. \n");
	}
	g_printf("thread ID : %d \n", t_id);

	// ===>
  	gtk_main ();
  	// ===>
  	g_printf("thread end. \n");

  return 0;
}

//-------------------------------------------------------------------------------------------------
// Function : thread initial
void thread_initial(void)
{
	// =====>
	flag = 0;

	// =====>
	g_printf("start server ! \n");
	
	serv_sock = socket(PF_INET, SOCK_STREAM, 0);
	
	if(serv_sock == -1){
		g_printf("socket 1 error. \n");
	}
	
	memset(&serv_addr, 0, sizeof(serv_addr));
	serv_addr.sin_family = AF_INET;
	serv_addr.sin_addr.s_addr = htonl(INADDR_ANY);
	serv_addr.sin_port = htons(atoi("9000"));
	
	if(bind(serv_sock, (struct sockaddr *) &serv_addr, sizeof(serv_addr)) == -1){
		g_printf("socket 2 error. \n");
	}

	if(listen(serv_sock, 5) == -1){
		g_printf("socket 3 error. \n");
	}
	
	clnt_addr_size = sizeof(clnt_addr);

	// =====>
	if(clnt_sock == -1){
		g_printf("socket 4 error. \n");
	}
}

//-------------------------------------------------------------------------------------------------
// Function : thread myloop
void *thread_myloop(void *arg)
{
	// client accept
	if(flag == 0){
		clnt_sock = accept(serv_sock, (struct sockaddr *)&clnt_addr, &clnt_addr_size);
		flag = 1;
	}

	// data send & receive
	while((str_len = read(clnt_sock, message, BUFSIZE)) != 0)
	{
		/*		
		memset(&rec, 0, str_len);
		memcpy(rec, message, str_len);
		*/
	
		write(clnt_sock, message, str_len);
		write(1, message, str_len);
		g_printf("\n");
		
		// ===>
		if((message[7] == 'S') && (message[8] == 'T') && (message[9] == 'O')){
			//g_printf("!!! SIGNAL_STOP\n");
			signal_stop();
		}
		else if((message[7] == 'A') && (message[8] == 'D') && (message[9] == 'V')){
			//g_printf("!!! SIGNAL_ADVANCE\n");
			signal_advance();
		}
		else if((message[7] == 'L') && (message[8] == 'E') && (message[9] == 'F')){
			//g_printf("!!! SIGNAL_LEFT\n");
			signal_left();
		}
		else if((message[7] == 'R') && (message[8] == 'I') && (message[9] == 'G')){
			//g_printf("!!! SIGNAL_RIGHT\n");
			signal_right();
		}
		else if((message[7] == 'D') && (message[8] == 'O') && (message[9] == 'W')){
			//g_printf("!!! SIGNAL_DOWN\n");
			signal_down();
		}
	}
}

//-------------------------------------------------------------------------------------------------
// Process - SIGNAL_STOP
void signal_stop(void)
{
	// server on/off switch
	if(g_flag_master == 0){
		return;
	}

	g_printf("_stop \n");
	fd = open("/dev/port", O_RDWR);
	lseek(fd, 0x378, SEEK_SET);
	buff[0] = 0x00;
	write(fd, buff, 1);
}

//-------------------------------------------------------------------------------------------------
// Process - SIGNAL_ADVANCE
void signal_advance(void)
{
	// server on/off switch
	if(g_flag_master == 0){
		return;
	}
	
	g_printf("_advance \n");
	fd = open("/dev/port", O_RDWR);
	lseek(fd, 0x378, SEEK_SET);
	buff[0] = 0xAA;
	write(fd, buff, 1);
}

//-------------------------------------------------------------------------------------------------
// Process - SIGNAL_LEFT
void signal_left(void)
{
	// server on/off switch
	if(g_flag_master == 0){
		return;
	}
	
	g_printf("_left \n");
	fd = open("/dev/port", O_RDWR);
	lseek(fd, 0x378, SEEK_SET);
	buff[0] = 0x66;
	write(fd, buff, 1);
}

//-------------------------------------------------------------------------------------------------
// Process - SIGNAL_RIGHT
void signal_right(void)
{
	// server on/off switch
	if(g_flag_master == 0){
		return;
	}
	
	g_printf("_right \n");
	fd = open("/dev/port", O_RDWR);
	lseek(fd, 0x378, SEEK_SET);
	buff[0] = 0x99;
	write(fd, buff, 1);
}

//-------------------------------------------------------------------------------------------------
// Process - SIGNAL_DOWN
void signal_down(void)
{
	// server on/off switch
	if(g_flag_master == 0){
		return;
	}
	
	g_printf("_down \n");
	fd = open("/dev/port", O_RDWR);
	lseek(fd, 0x378, SEEK_SET);
	buff[0] = 0x55;
	write(fd, buff, 1);
}

